require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__BITS_IOCTLS_H)) {
    eval 'sub __BITS_IOCTLS_H () {1;}' unless defined(&__BITS_IOCTLS_H);
    if(!defined (&_HURD_IOCTL_H)  && !defined (&_SYS_IOCTL_H)) {
	die("Never use <bits/ioctls.h> directly; include <hurd/ioctl.h> instead.");
    }
    if(defined(&__USE_MISC)) {
	if(defined(&NL0)) {
	    undef(&NL0) if defined(&NL0);
	}
	if(defined(&NL1)) {
	    undef(&NL1) if defined(&NL1);
	}
	if(defined(&TAB0)) {
	    undef(&TAB0) if defined(&TAB0);
	}
	if(defined(&TAB1)) {
	    undef(&TAB1) if defined(&TAB1);
	}
	if(defined(&TAB2)) {
	    undef(&TAB2) if defined(&TAB2);
	}
	if(defined(&CR0)) {
	    undef(&CR0) if defined(&CR0);
	}
	if(defined(&CR1)) {
	    undef(&CR1) if defined(&CR1);
	}
	if(defined(&CR2)) {
	    undef(&CR2) if defined(&CR2);
	}
	if(defined(&CR3)) {
	    undef(&CR3) if defined(&CR3);
	}
	if(defined(&FF0)) {
	    undef(&FF0) if defined(&FF0);
	}
	if(defined(&FF1)) {
	    undef(&FF1) if defined(&FF1);
	}
	if(defined(&BS0)) {
	    undef(&BS0) if defined(&BS0);
	}
	if(defined(&BS1)) {
	    undef(&BS1) if defined(&BS1);
	}
	if(defined(&MDMBUF)) {
	    undef(&MDMBUF) if defined(&MDMBUF);
	}
	if(defined(&ECHO)) {
	    undef(&ECHO) if defined(&ECHO);
	}
	if(defined(&TOSTOP)) {
	    undef(&TOSTOP) if defined(&TOSTOP);
	}
	if(defined(&FLUSHO)) {
	    undef(&FLUSHO) if defined(&FLUSHO);
	}
	if(defined(&PENDIN)) {
	    undef(&PENDIN) if defined(&PENDIN);
	}
	if(defined(&NOFLSH)) {
	    undef(&NOFLSH) if defined(&NOFLSH);
	}
    }
    eval("sub IOC_VOID () { 0; }") unless defined(&IOC_VOID);
    eval("sub IOC_OUT () { 1; }") unless defined(&IOC_OUT);
    eval("sub IOC_IN () { 2; }") unless defined(&IOC_IN);
    eval("sub IOC_INOUT () { (IOC_IN|IOC_OUT); }") unless defined(&IOC_INOUT);
    eval("sub IOC_8 () { 0; }") unless defined(&IOC_8);
    eval("sub IOC_16 () { 1; }") unless defined(&IOC_16);
    eval("sub IOC_32 () { 2; }") unless defined(&IOC_32);
    eval("sub IOC_64 () { 3; }") unless defined(&IOC_64);
    eval 'sub _IOC {
        my($inout, $group, $num, $type) = @_;
	    eval q((($num) | (((($group) - ord(\'f\')) | (($type) | ($inout) << 19) << 4) << 7)));
    }' unless defined(&_IOC);
    eval 'sub _IOC_INOUT {
        my($request) = @_;
	    eval q((( ($request) >> 30) &  &IOC_INOUT));
    }' unless defined(&_IOC_INOUT);
    eval 'sub _IOC_GROUP {
        my($request) = @_;
	    eval q((ord(\'f\') + (( ($request) >> 7) & 0xf)));
    }' unless defined(&_IOC_GROUP);
    eval 'sub _IOC_COMMAND {
        my($request) = @_;
	    eval q(( ($request) & 0x7f));
    }' unless defined(&_IOC_COMMAND);
    eval 'sub _IOC_TYPE {
        my($request) = @_;
	    eval q((( ($request) >> 11) & 0x7ffff));
    }' unless defined(&_IOC_TYPE);
    eval 'sub _IOC_NOTYPE {
        my($request) = @_;
	    eval q(( ($request) & 0x3ff));
    }' unless defined(&_IOC_NOTYPE);
    eval 'sub _IOT {
        my($t0, $c0, $t1, $c1, $t2, $c2) = @_;
	    eval q((($c2) | ((($c1) | (($c0) | (($t2) | (($t1) | ($t0) << 2) << 2) << 5) << 5) << 3)));
    }' unless defined(&_IOT);
    eval 'sub _IOT_TYPE0 {
        my($type) = @_;
	    eval q((( ($type) >> 17) & 3));
    }' unless defined(&_IOT_TYPE0);
    eval 'sub _IOT_TYPE1 {
        my($type) = @_;
	    eval q((( ($type) >> 15) & 3));
    }' unless defined(&_IOT_TYPE1);
    eval 'sub _IOT_TYPE2 {
        my($type) = @_;
	    eval q((( ($type) >> 13) & 3));
    }' unless defined(&_IOT_TYPE2);
    eval 'sub _IOT_COUNT0 {
        my($type) = @_;
	    eval q((( ($type) >> 8) & 0x1f));
    }' unless defined(&_IOT_COUNT0);
    eval 'sub _IOT_COUNT1 {
        my($type) = @_;
	    eval q((( ($type) >> 3) & 0x1f));
    }' unless defined(&_IOT_COUNT1);
    eval 'sub _IOT_COUNT2 {
        my($type) = @_;
	    eval q((( ($type) >> 0) & 7));
    }' unless defined(&_IOT_COUNT2);
    eval 'sub _IOCT {
        my($inout, $group, $num, $t0, $c0, $t1, $c1, $t2, $c2) = @_;
	    eval q( &_IOC (($inout), ($group), ($num),  &_IOT (($t0), ($c0), ($t1), ($c1), ($t2), ($c2))));
    }' unless defined(&_IOCT);
    eval 'sub _IOTS {
        my($type) = @_;
	    eval q(($sizeof{$type} == 8?  &IOC_64 : ( &enum  &__ioctl_datum) ($sizeof{$type} >> 1)));
    }' unless defined(&_IOTS);
    eval 'sub _IOT_SIMPLE {
        my($type) = @_;
	    eval q( &_IOT ( &_IOTS ($type), 1, 0, 0, 0, 0));
    }' unless defined(&_IOT_SIMPLE);
    eval 'sub _IOT__IOTBASE_char () { &_IOT_SIMPLE ;}' unless defined(&_IOT__IOTBASE_char);
    eval 'sub _IOT__IOTBASE_short () { &_IOT_SIMPLE ;}' unless defined(&_IOT__IOTBASE_short);
    eval 'sub _IOT__IOTBASE_int () { &_IOT_SIMPLE ;}' unless defined(&_IOT__IOTBASE_int);
    eval 'sub _IOT__IOTBASE_long () { &_IOT_SIMPLE ;}' unless defined(&_IOT__IOTBASE_long);
    eval 'sub _IOT_char () { &_IOT_SIMPLE ;}' unless defined(&_IOT_char);
    eval 'sub _IOT_short () { &_IOT_SIMPLE ;}' unless defined(&_IOT_short);
    eval 'sub _IOT_int () { &_IOT_SIMPLE ;}' unless defined(&_IOT_int);
    eval 'sub _IOT_long () { &_IOT_SIMPLE ;}' unless defined(&_IOT_long);
    eval 'sub _IOT__IOTBASE_int8_t () { &_IOT_SIMPLE ( &int8_t);}' unless defined(&_IOT__IOTBASE_int8_t);
    eval 'sub _IOT__IOTBASE_uint8_t () { &_IOT_SIMPLE ( &uint8_t);}' unless defined(&_IOT__IOTBASE_uint8_t);
    eval 'sub _IOT__IOTBASE_int16_t () { &_IOT_SIMPLE ( &int16_t);}' unless defined(&_IOT__IOTBASE_int16_t);
    eval 'sub _IOT__IOTBASE_uint16_t () { &_IOT_SIMPLE ( &uint16_t);}' unless defined(&_IOT__IOTBASE_uint16_t);
    eval 'sub _IOT__IOTBASE_int32_t () { &_IOT_SIMPLE ( &int32_t);}' unless defined(&_IOT__IOTBASE_int32_t);
    eval 'sub _IOT__IOTBASE_uint32_t () { &_IOT_SIMPLE ( &uint32_t);}' unless defined(&_IOT__IOTBASE_uint32_t);
    eval 'sub _IOT__IOTBASE_int64_t () { &_IOT_SIMPLE ( &int64_t);}' unless defined(&_IOT__IOTBASE_int64_t);
    eval 'sub _IOT__IOTBASE_uint64_t () { &_IOT_SIMPLE ( &uint64_t);}' unless defined(&_IOT__IOTBASE_uint64_t);
    eval 'sub _IOT__IOTBASE_size_t () { &_IOT_SIMPLE ;}' unless defined(&_IOT__IOTBASE_size_t);
    eval 'sub _IOT__IOTBASE_ssize_t () { &_IOT_SIMPLE ( &ssize_t);}' unless defined(&_IOT__IOTBASE_ssize_t);
    eval 'sub _IO {
        my($g, $n) = @_;
	    eval q( &_IOC ( &IOC_VOID, ($g), ($n), 0));
    }' unless defined(&_IO);
    eval 'sub _IOIW {
        my($g, $n, $t) = @_;
	    eval q( &_IOC ( &IOC_VOID, ($g), ($n),  &_IOC_ENCODE_TYPE ($t)));
    }' unless defined(&_IOIW);
    eval 'sub _IOR {
        my($g, $n, $t) = @_;
	    eval q( &_IOC ( &IOC_OUT, ($g), ($n),  &_IOC_ENCODE_TYPE ($t)));
    }' unless defined(&_IOR);
    eval 'sub _IOW {
        my($g, $n, $t) = @_;
	    eval q( &_IOC ( &IOC_IN, ($g), ($n),  &_IOC_ENCODE_TYPE ($t)));
    }' unless defined(&_IOW);
    eval 'sub _IOWR {
        my($g, $n, $t) = @_;
	    eval q( &_IOC ( &IOC_INOUT, ($g), ($n),  &_IOC_ENCODE_TYPE ($t)));
    }' unless defined(&_IOWR);
    eval 'sub _IOC_ENCODE_TYPE {
        my($typespec) = @_;
	    eval q( &_IOC_ENCODE_TYPE_1( &_IOTBASE_$typespec));
    }' unless defined(&_IOC_ENCODE_TYPE);
    eval 'sub _IOTBASE_struct () {1;}' unless defined(&_IOTBASE_struct);
    eval 'sub _IOC_ENCODE_TYPE_1 {
        my($typespec) = @_;
	    eval q( &_IOC_ENCODE_TYPE_2($typespec));
    }' unless defined(&_IOC_ENCODE_TYPE_1);
    eval 'sub _IOC_ENCODE_TYPE_2 {
        my($typespec) = @_;
	    eval q( &_IOT_$typespec);
    }' unless defined(&_IOC_ENCODE_TYPE_2);
    eval 'sub _IOTBASE_unsigned () {1;}' unless defined(&_IOTBASE_unsigned);
    eval 'sub _IOTBASE_signed () {1;}' unless defined(&_IOTBASE_signed);
    eval 'sub TIOCMODG () { &_IOR(ord(\'t\'), 3, \'int\');}' unless defined(&TIOCMODG);
    eval 'sub TIOCMODS () { &_IOW(ord(\'t\'), 4, \'int\');}' unless defined(&TIOCMODS);
    eval 'sub TIOCM_LE () {0001;}' unless defined(&TIOCM_LE);
    eval 'sub TIOCM_DTR () {0002;}' unless defined(&TIOCM_DTR);
    eval 'sub TIOCM_RTS () {0004;}' unless defined(&TIOCM_RTS);
    eval 'sub TIOCM_ST () {0010;}' unless defined(&TIOCM_ST);
    eval 'sub TIOCM_SR () {0020;}' unless defined(&TIOCM_SR);
    eval 'sub TIOCM_CTS () {0040;}' unless defined(&TIOCM_CTS);
    eval 'sub TIOCM_CAR () {0100;}' unless defined(&TIOCM_CAR);
    eval 'sub TIOCM_CD () { &TIOCM_CAR;}' unless defined(&TIOCM_CD);
    eval 'sub TIOCM_RNG () {0200;}' unless defined(&TIOCM_RNG);
    eval 'sub TIOCM_RI () { &TIOCM_RNG;}' unless defined(&TIOCM_RI);
    eval 'sub TIOCM_DSR () {0400;}' unless defined(&TIOCM_DSR);
    eval 'sub TIOCEXCL () { &_IO(ord(\'t\'), 13);}' unless defined(&TIOCEXCL);
    eval 'sub TIOCNXCL () { &_IO(ord(\'t\'), 14);}' unless defined(&TIOCNXCL);
    eval 'sub TIOCFLUSH () { &_IOW(ord(\'t\'), 16, \'int\');}' unless defined(&TIOCFLUSH);
    eval 'sub TIOCGETA () { &_IOR(ord(\'t\'), 19, 1;}' unless defined(&TIOCGETA);
    eval 'sub TIOCSETA () { &_IOW(ord(\'t\'), 20, 1;}' unless defined(&TIOCSETA);
    eval 'sub TIOCSETAW () { &_IOW(ord(\'t\'), 21, 1;}' unless defined(&TIOCSETAW);
    eval 'sub TIOCSETAF () { &_IOW(ord(\'t\'), 22, 1;}' unless defined(&TIOCSETAF);
    eval 'sub TIOCGETD () { &_IOR(ord(\'t\'), 26, \'int\');}' unless defined(&TIOCGETD);
    eval 'sub TIOCSETD () { &_IOW(ord(\'t\'), 27, \'int\');}' unless defined(&TIOCSETD);
    eval 'sub TIOCSBRK () { &_IO(ord(\'t\'), 123);}' unless defined(&TIOCSBRK);
    eval 'sub TIOCCBRK () { &_IO(ord(\'t\'), 122);}' unless defined(&TIOCCBRK);
    eval 'sub TIOCSDTR () { &_IO(ord(\'t\'), 121);}' unless defined(&TIOCSDTR);
    eval 'sub TIOCCDTR () { &_IO(ord(\'t\'), 120);}' unless defined(&TIOCCDTR);
    eval 'sub TIOCGPGRP () { &_IOR(ord(\'t\'), 119, \'int\');}' unless defined(&TIOCGPGRP);
    eval 'sub TIOCSPGRP () { &_IOW(ord(\'t\'), 118, \'int\');}' unless defined(&TIOCSPGRP);
    eval 'sub TIOCOUTQ () { &_IOR(ord(\'t\'), 115, \'int\');}' unless defined(&TIOCOUTQ);
    eval 'sub TIOCSTI () { &_IOW(ord(\'t\'), 114, \'char\');}' unless defined(&TIOCSTI);
    eval 'sub TIOCNOTTY () { &_IO(ord(\'t\'), 113);}' unless defined(&TIOCNOTTY);
    eval 'sub TIOCPKT () { &_IOW(ord(\'t\'), 112, \'int\');}' unless defined(&TIOCPKT);
    eval 'sub TIOCPKT_DATA () {0x;}' unless defined(&TIOCPKT_DATA);
    eval 'sub TIOCPKT_FLUSHREAD () {0x1;}' unless defined(&TIOCPKT_FLUSHREAD);
    eval 'sub TIOCPKT_FLUSHWRITE () {0x2;}' unless defined(&TIOCPKT_FLUSHWRITE);
    eval 'sub TIOCPKT_STOP () {0x4;}' unless defined(&TIOCPKT_STOP);
    eval 'sub TIOCPKT_START () {0x8;}' unless defined(&TIOCPKT_START);
    eval 'sub TIOCPKT_NOSTOP () {0x10;}' unless defined(&TIOCPKT_NOSTOP);
    eval 'sub TIOCPKT_DOSTOP () {0x20;}' unless defined(&TIOCPKT_DOSTOP);
    eval 'sub TIOCPKT_IOCTL () {0x40;}' unless defined(&TIOCPKT_IOCTL);
    eval 'sub TIOCSTOP () { &_IO(ord(\'t\'), 111);}' unless defined(&TIOCSTOP);
    eval 'sub TIOCSTART () { &_IO(ord(\'t\'), 110);}' unless defined(&TIOCSTART);
    eval 'sub TIOCMSET () { &_IOW(ord(\'t\'), 109, \'int\');}' unless defined(&TIOCMSET);
    eval 'sub TIOCMBIS () { &_IOW(ord(\'t\'), 108, \'int\');}' unless defined(&TIOCMBIS);
    eval 'sub TIOCMBIC () { &_IOW(ord(\'t\'), 107, \'int\');}' unless defined(&TIOCMBIC);
    eval 'sub TIOCMGET () { &_IOR(ord(\'t\'), 106, \'int\');}' unless defined(&TIOCMGET);
    eval 'sub TIOCREMOTE () { &_IOW(ord(\'t\'), 105, \'int\');}' unless defined(&TIOCREMOTE);
    eval 'sub TIOCGWINSZ () { &_IOR(ord(\'t\'), 104, 1;}' unless defined(&TIOCGWINSZ);
    eval 'sub TIOCSWINSZ () { &_IOW(ord(\'t\'), 103, 1;}' unless defined(&TIOCSWINSZ);
    eval 'sub TIOCUCNTL () { &_IOW(ord(\'t\'), 102, \'int\');}' unless defined(&TIOCUCNTL);
    eval 'sub UIOCCMD {
        my($n) = @_;
	    eval q( &_IO(ord(\'u\'), $n));
    }' unless defined(&UIOCCMD);
    eval 'sub TIOCCONS () { &_IOW(ord(\'t\'), 98, \'int\');}' unless defined(&TIOCCONS);
    eval 'sub TIOCSCTTY () { &_IO(ord(\'t\'), 97);}' unless defined(&TIOCSCTTY);
    eval 'sub TIOCEXT () { &_IOW(ord(\'t\'), 96, \'int\');}' unless defined(&TIOCEXT);
    eval 'sub TIOCSIG () { &_IO(ord(\'t\'), 95);}' unless defined(&TIOCSIG);
    eval 'sub TIOCDRAIN () { &_IO(ord(\'t\'), 94);}' unless defined(&TIOCDRAIN);
    eval 'sub TTYDISC () {0;}' unless defined(&TTYDISC);
    eval 'sub TABLDISC () {3;}' unless defined(&TABLDISC);
    eval 'sub SLIPDISC () {4;}' unless defined(&SLIPDISC);
    eval 'sub FIOCLEX () { &_IO(ord(\'f\'), 1);}' unless defined(&FIOCLEX);
    eval 'sub FIONCLEX () { &_IO(ord(\'f\'), 2);}' unless defined(&FIONCLEX);
    eval 'sub FIONREAD () { &_IOR(ord(\'f\'), 127, \'int\');}' unless defined(&FIONREAD);
    eval 'sub FIONBIO () { &_IOW(ord(\'f\'), 126, \'int\');}' unless defined(&FIONBIO);
    eval 'sub FIOASYNC () { &_IOW(ord(\'f\'), 125, \'int\');}' unless defined(&FIOASYNC);
    eval 'sub FIOSETOWN () { &_IOW(ord(\'f\'), 124, \'int\');}' unless defined(&FIOSETOWN);
    eval 'sub FIOGETOWN () { &_IOR(ord(\'f\'), 123, \'int\');}' unless defined(&FIOGETOWN);
    if(0) {
	eval 'sub SIOCSHIWAT () { &_IOW(ord(\'s\'), 0, \'int\');}' unless defined(&SIOCSHIWAT);
	eval 'sub SIOCGHIWAT () { &_IOR(ord(\'s\'), 1, \'int\');}' unless defined(&SIOCGHIWAT);
	eval 'sub SIOCSLOWAT () { &_IOW(ord(\'s\'), 2, \'int\');}' unless defined(&SIOCSLOWAT);
	eval 'sub SIOCGLOWAT () { &_IOR(ord(\'s\'), 3, \'int\');}' unless defined(&SIOCGLOWAT);
    }
    eval 'sub SIOCATMARK () { &_IOR(ord(\'s\'), 7, \'int\');}' unless defined(&SIOCATMARK);
    eval 'sub SIOCSPGRP () { &_IOW(ord(\'s\'), 8, \'int\');}' unless defined(&SIOCSPGRP);
    eval 'sub SIOCGPGRP () { &_IOR(ord(\'s\'), 9, \'int\');}' unless defined(&SIOCGPGRP);
    eval 'sub SIOCADDRT () { &_IOW(ord(\'r\'), 10, 1;}' unless defined(&SIOCADDRT);
    eval 'sub SIOCDELRT () { &_IOW(ord(\'r\'), 11, 1;}' unless defined(&SIOCDELRT);
    eval 'sub SIOCSIFADDR () { &_IOW(ord(\'i\'), 12, 1;}' unless defined(&SIOCSIFADDR);
    eval 'sub OSIOCGIFADDR () { &_IOWR(ord(\'i\'),13, 1;}' unless defined(&OSIOCGIFADDR);
    eval 'sub SIOCGIFADDR () { &_IOWR(ord(\'i\'),33, 1;}' unless defined(&SIOCGIFADDR);
    eval 'sub SIOCGIFHWADDR () { &_IOWR(ord(\'i\'),39, 1;}' unless defined(&SIOCGIFHWADDR);
    eval 'sub SIOCSIFDSTADDR () { &_IOW(ord(\'i\'), 14, 1;}' unless defined(&SIOCSIFDSTADDR);
    eval 'sub OSIOCGIFDSTADDR () { &_IOWR(ord(\'i\'),15, 1;}' unless defined(&OSIOCGIFDSTADDR);
    eval 'sub SIOCGIFDSTADDR () { &_IOWR(ord(\'i\'),34, 1;}' unless defined(&SIOCGIFDSTADDR);
    eval 'sub SIOCSIFFLAGS () { &_IOW(ord(\'i\'), 16, 1;}' unless defined(&SIOCSIFFLAGS);
    eval 'sub SIOCGIFFLAGS () { &_IOWR(ord(\'i\'),17, 1;}' unless defined(&SIOCGIFFLAGS);
    eval 'sub OSIOCGIFBRDADDR () { &_IOWR(ord(\'i\'),18, 1;}' unless defined(&OSIOCGIFBRDADDR);
    eval 'sub SIOCGIFBRDADDR () { &_IOWR(ord(\'i\'),35, 1;}' unless defined(&SIOCGIFBRDADDR);
    eval 'sub SIOCSIFBRDADDR () { &_IOW(ord(\'i\'),19, 1;}' unless defined(&SIOCSIFBRDADDR);
    eval 'sub OSIOCGIFCONF () { &_IOWR(ord(\'i\'),20, 1;}' unless defined(&OSIOCGIFCONF);
    eval 'sub SIOCGIFCONF () { &_IOWR(ord(\'i\'),36, 1;}' unless defined(&SIOCGIFCONF);
    eval 'sub OSIOCGIFNETMASK () { &_IOWR(ord(\'i\'),21, 1;}' unless defined(&OSIOCGIFNETMASK);
    eval 'sub SIOCGIFNETMASK () { &_IOWR(ord(\'i\'),37, 1;}' unless defined(&SIOCGIFNETMASK);
    eval 'sub SIOCSIFNETMASK () { &_IOW(ord(\'i\'),22, 1;}' unless defined(&SIOCSIFNETMASK);
    eval 'sub SIOCGIFMETRIC () { &_IOWR(ord(\'i\'),23, 1;}' unless defined(&SIOCGIFMETRIC);
    eval 'sub SIOCSIFMETRIC () { &_IOW(ord(\'i\'),24, 1;}' unless defined(&SIOCSIFMETRIC);
    eval 'sub SIOCDIFADDR () { &_IOW(ord(\'i\'),25, 1;}' unless defined(&SIOCDIFADDR);
    if(0) {
	eval 'sub SIOCAIFADDR () { &_IOW(ord(\'i\'),26, 1;}' unless defined(&SIOCAIFADDR);
    }
    if(0) {
	eval 'sub SIOCSARP () { &_IOW(ord(\'i\'), 30, 1;}' unless defined(&SIOCSARP);
	eval 'sub OSIOCGARP () { &_IOWR(ord(\'i\'),31, 1;}' unless defined(&OSIOCGARP);
	eval 'sub SIOCGARP () { &_IOWR(ord(\'i\'),38, 1;}' unless defined(&SIOCGARP);
	eval 'sub SIOCDARP () { &_IOW(ord(\'i\'), 32, 1;}' unless defined(&SIOCDARP);
    }
    eval 'sub SIOCGIFMTU () { &_IOWR(ord(\'i\'), 51, 1;}' unless defined(&SIOCGIFMTU);
    eval 'sub SIOCSIFMTU () { &_IOW(ord(\'i\'), 52, 1;}' unless defined(&SIOCSIFMTU);
    eval 'sub SIOCGIFINDEX () { &_IOWR(ord(\'i\'), 90, 1;}' unless defined(&SIOCGIFINDEX);
    eval 'sub SIOCGIFNAME () { &_IOWR(ord(\'i\'), 91, 1;}' unless defined(&SIOCGIFNAME);
    if(defined(&__USE_MISC)) {
	if(defined(&USE_OLD_TTY)) {
	    undef(&TIOCGETD) if defined(&TIOCGETD);
	    eval 'sub TIOCGETD () { &_IOR(ord(\'t\'), 0, \'int\');}' unless defined(&TIOCGETD);
	    undef(&TIOCSETD) if defined(&TIOCSETD);
	    eval 'sub TIOCSETD () { &_IOW(ord(\'t\'), 1, \'int\');}' unless defined(&TIOCSETD);
	} else {
	    eval 'sub OTIOCGETD () { &_IOR(ord(\'t\'), 0, \'int\');}' unless defined(&OTIOCGETD);
	    eval 'sub OTIOCSETD () { &_IOW(ord(\'t\'), 1, \'int\');}' unless defined(&OTIOCSETD);
	}
	if(0) {
	    eval 'sub TIOCHPCL () { &_IO(ord(\'t\'), 2);}' unless defined(&TIOCHPCL);
	}
	eval 'sub TIOCGETP () { &_IOR(ord(\'t\'), 8,1;}' unless defined(&TIOCGETP);
	eval 'sub TIOCSETP () { &_IOW(ord(\'t\'), 9,1;}' unless defined(&TIOCSETP);
	eval 'sub TIOCSETN () { &_IOW(ord(\'t\'),10,1;}' unless defined(&TIOCSETN);
	eval 'sub TIOCSETC () { &_IOW(ord(\'t\'),17,1;}' unless defined(&TIOCSETC);
	eval 'sub TIOCGETC () { &_IOR(ord(\'t\'),18,1;}' unless defined(&TIOCGETC);
	eval 'sub TANDEM () {0x1;}' unless defined(&TANDEM);
	eval 'sub CBREAK () {0x2;}' unless defined(&CBREAK);
	eval 'sub LCASE () {0x4;}' unless defined(&LCASE);
	eval 'sub ECHO () {0x8;}' unless defined(&ECHO);
	eval 'sub CRMOD () {0x10;}' unless defined(&CRMOD);
	eval 'sub RAW () {0x20;}' unless defined(&RAW);
	eval 'sub ODDP () {0x40;}' unless defined(&ODDP);
	eval 'sub EVENP () {0x80;}' unless defined(&EVENP);
	eval 'sub ANYP () {0xc0;}' unless defined(&ANYP);
	eval 'sub NLDELAY () {0x300;}' unless defined(&NLDELAY);
	eval 'sub NL0 () {0x;}' unless defined(&NL0);
	eval 'sub NL1 () {0x100;}' unless defined(&NL1);
	eval 'sub NL2 () {0x200;}' unless defined(&NL2);
	eval 'sub NL3 () {0x300;}' unless defined(&NL3);
	eval 'sub TBDELAY () {0xc00;}' unless defined(&TBDELAY);
	eval 'sub TAB0 () {0x;}' unless defined(&TAB0);
	eval 'sub TAB1 () {0x400;}' unless defined(&TAB1);
	eval 'sub TAB2 () {0x800;}' unless defined(&TAB2);
	eval 'sub XTABS () {0xc00;}' unless defined(&XTABS);
	eval 'sub CRDELAY () {0x3000;}' unless defined(&CRDELAY);
	eval 'sub CR0 () {0x;}' unless defined(&CR0);
	eval 'sub CR1 () {0x1000;}' unless defined(&CR1);
	eval 'sub CR2 () {0x2000;}' unless defined(&CR2);
	eval 'sub CR3 () {0x3000;}' unless defined(&CR3);
	eval 'sub VTDELAY () {0x4000;}' unless defined(&VTDELAY);
	eval 'sub FF0 () {0x;}' unless defined(&FF0);
	eval 'sub FF1 () {0x4000;}' unless defined(&FF1);
	eval 'sub BSDELAY () {0x8000;}' unless defined(&BSDELAY);
	eval 'sub BS0 () {0x;}' unless defined(&BS0);
	eval 'sub BS1 () {0x8000;}' unless defined(&BS1);
	eval 'sub ALLDELAY () {( &NLDELAY| &TBDELAY| &CRDELAY| &VTDELAY| &BSDELAY);}' unless defined(&ALLDELAY);
	eval 'sub CRTBS () {0x10000;}' unless defined(&CRTBS);
	eval 'sub PRTERA () {0x20000;}' unless defined(&PRTERA);
	eval 'sub CRTERA () {0x40000;}' unless defined(&CRTERA);
	eval 'sub TILDE () {0x80000;}' unless defined(&TILDE);
	eval 'sub MDMBUF () {0x100000;}' unless defined(&MDMBUF);
	eval 'sub LITOUT () {0x200000;}' unless defined(&LITOUT);
	eval 'sub TOSTOP () {0x400000;}' unless defined(&TOSTOP);
	eval 'sub FLUSHO () {0x800000;}' unless defined(&FLUSHO);
	eval 'sub NOHANG () {0x1000000;}' unless defined(&NOHANG);
	eval 'sub L001000 () {0x2000000;}' unless defined(&L001000);
	eval 'sub CRTKIL () {0x4000000;}' unless defined(&CRTKIL);
	eval 'sub PASS8 () {0x8000000;}' unless defined(&PASS8);
	eval 'sub CTLECH () {0x10000000;}' unless defined(&CTLECH);
	eval 'sub PENDIN () {0x20000000;}' unless defined(&PENDIN);
	eval 'sub DECCTQ () {0x40000000;}' unless defined(&DECCTQ);
	eval 'sub NOFLSH () {0x80000000;}' unless defined(&NOFLSH);
	if(0) {
	    eval 'sub TIOCLBIS () { &_IOW(ord(\'t\'), 127, \'int\');}' unless defined(&TIOCLBIS);
	    eval 'sub TIOCLBIC () { &_IOW(ord(\'t\'), 126, \'int\');}' unless defined(&TIOCLBIC);
	    eval 'sub TIOCLSET () { &_IOW(ord(\'t\'), 125, \'int\');}' unless defined(&TIOCLSET);
	    eval 'sub TIOCLGET () { &_IOR(ord(\'t\'), 124, \'int\');}' unless defined(&TIOCLGET);
	    eval 'sub LCRTBS () {( &CRTBS>>16);}' unless defined(&LCRTBS);
	    eval 'sub LPRTERA () {( &PRTERA>>16);}' unless defined(&LPRTERA);
	    eval 'sub LCRTERA () {( &CRTERA>>16);}' unless defined(&LCRTERA);
	    eval 'sub LTILDE () {( &TILDE>>16);}' unless defined(&LTILDE);
	    eval 'sub LMDMBUF () {( &MDMBUF>>16);}' unless defined(&LMDMBUF);
	    eval 'sub LLITOUT () {( &LITOUT>>16);}' unless defined(&LLITOUT);
	    eval 'sub LTOSTOP () {( &TOSTOP>>16);}' unless defined(&LTOSTOP);
	    eval 'sub LFLUSHO () {( &FLUSHO>>16);}' unless defined(&LFLUSHO);
	    eval 'sub LNOHANG () {( &NOHANG>>16);}' unless defined(&LNOHANG);
	    eval 'sub LCRTKIL () {( &CRTKIL>>16);}' unless defined(&LCRTKIL);
	    eval 'sub LPASS8 () {( &PASS8>>16);}' unless defined(&LPASS8);
	    eval 'sub LCTLECH () {( &CTLECH>>16);}' unless defined(&LCTLECH);
	    eval 'sub LPENDIN () {( &PENDIN>>16);}' unless defined(&LPENDIN);
	    eval 'sub LDECCTQ () {( &DECCTQ>>16);}' unless defined(&LDECCTQ);
	    eval 'sub LNOFLSH () {( &NOFLSH>>16);}' unless defined(&LNOFLSH);
	    eval 'sub TIOCSLTC () { &_IOW(ord(\'t\'),117,1;}' unless defined(&TIOCSLTC);
	    eval 'sub TIOCGLTC () { &_IOR(ord(\'t\'),116,1;}' unless defined(&TIOCGLTC);
	    eval 'sub OTIOCCONS () { &_IO(ord(\'t\'), 98);}' unless defined(&OTIOCCONS);
	    eval 'sub OTTYDISC () {0;}' unless defined(&OTTYDISC);
	    eval 'sub NETLDISC () {1;}' unless defined(&NETLDISC);
	    eval 'sub NTTYDISC () {2;}' unless defined(&NTTYDISC);
	}
	if(defined(&USE_OLD_TTY)) {
	    eval 'sub B0 () {0;}' unless defined(&B0);
	    eval 'sub B50 () {1;}' unless defined(&B50);
	    eval 'sub B75 () {2;}' unless defined(&B75);
	    eval 'sub B110 () {3;}' unless defined(&B110);
	    eval 'sub B134 () {4;}' unless defined(&B134);
	    eval 'sub B150 () {5;}' unless defined(&B150);
	    eval 'sub B200 () {6;}' unless defined(&B200);
	    eval 'sub B300 () {7;}' unless defined(&B300);
	    eval 'sub B600 () {8;}' unless defined(&B600);
	    eval 'sub B1200 () {9;}' unless defined(&B1200);
	    eval 'sub B1800 () {10;}' unless defined(&B1800);
	    eval 'sub B2400 () {11;}' unless defined(&B2400);
	    eval 'sub B4800 () {12;}' unless defined(&B4800);
	    eval 'sub B9600 () {13;}' unless defined(&B9600);
	    eval 'sub EXTA () {14;}' unless defined(&EXTA);
	    eval 'sub EXTB () {15;}' unless defined(&EXTB);
	}
    }
}
1;
