require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BITS_SIGACTION_H)) {
    eval 'sub _BITS_SIGACTION_H () {1;}' unless defined(&_BITS_SIGACTION_H);
    unless(defined(&_SIGNAL_H)) {
	die("Never include <bits/sigaction.h> directly; use <signal.h> instead.");
    }
    if(defined (&__USE_POSIX199309) || defined (&__USE_XOPEN_EXTENDED)) {
	eval 'sub sa_handler () { ($__sigaction_handler->{sa_handler});}' unless defined(&sa_handler);
	eval 'sub sa_sigaction () { ($__sigaction_handler->{sa_sigaction});}' unless defined(&sa_sigaction);
    } else {
    }
    if(defined (&__USE_XOPEN_EXTENDED) || defined (&__USE_MISC)) {
	eval 'sub SA_ONSTACK () {0x1;}' unless defined(&SA_ONSTACK);
    }
    if(defined (&__USE_XOPEN_EXTENDED) || defined (&__USE_XOPEN2K8)) {
	eval 'sub SA_RESTART () {0x2;}' unless defined(&SA_RESTART);
	eval 'sub SA_NODEFER () {0x10;}' unless defined(&SA_NODEFER);
	eval 'sub SA_RESETHAND () {0x4;}' unless defined(&SA_RESETHAND);
    }
    eval 'sub SA_NOCLDSTOP () {0x8;}' unless defined(&SA_NOCLDSTOP);
    eval 'sub SA_SIGINFO () {0x40;}' unless defined(&SA_SIGINFO);
    if(defined(&__USE_MISC)) {
	eval 'sub SA_INTERRUPT () {0;}' unless defined(&SA_INTERRUPT);
	eval 'sub SA_NOMASK () { &SA_NODEFER;}' unless defined(&SA_NOMASK);
	eval 'sub SA_ONESHOT () { &SA_RESETHAND;}' unless defined(&SA_ONESHOT);
	eval 'sub SA_STACK () { &SA_ONSTACK;}' unless defined(&SA_STACK);
    }
    eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
    eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
    eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
}
1;
