require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_IOCTL_H)) {
    die("Never use <bits/ioctl-types.h> directly; include <sys/ioctl.h> instead.");
}
if(defined (&TIOCGETC) || defined (&TIOCSETC)) {
    eval 'sub _IOT_tchars () { &_IOT ( &_IOTS , 6, 0, 0, 0, 0);}' unless defined(&_IOT_tchars);
}
if(defined (&TIOCGLTC) || defined (&TIOCSLTC)) {
    eval 'sub _IOT_ltchars () { &_IOT ( &_IOTS , 6, 0, 0, 0, 0);}' unless defined(&_IOT_ltchars);
}
eval 'sub _IOT_sgttyb () { &_IOT ( &_IOTS , 4,  &_IOTS , 1, 0, 0);}' unless defined(&_IOT_sgttyb);
if(defined (&TIOCGWINSZ) || defined (&TIOCSWINSZ)) {
    eval 'sub _IOT_winsize () { &_IOT ( &_IOTS , 4, 0, 0, 0, 0);}' unless defined(&_IOT_winsize);
}
if(defined (&TIOCGSIZE) || defined (&TIOCSSIZE)) {
    eval 'sub sizeof {
        my($type) = @_;
	    eval q(0);
    }' unless defined(&sizeof);
    if(defined (&TIOCGWINSZ)  && (defined(&TIOCGSIZE) ? &TIOCGSIZE : undef) == (defined(&TIOCGWINSZ) ? &TIOCGWINSZ : undef)) {
	eval 'sub _IOT_ttysize () { &_IOT_winsize;}' unless defined(&_IOT_ttysize);
    } else {
    }
    undef(&sizeof) if defined(&sizeof);
}
1;
