require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_BITS_TYPES_H)  && !defined (&_PTHREAD_H)) {
    die("Never include <bits/pthreadtypes.h> directly; use <sys/types.h> instead.");
}
unless(defined(&_BITS_PTHREADTYPES_H)) {
    eval 'sub _BITS_PTHREADTYPES_H () {1;}' unless defined(&_BITS_PTHREADTYPES_H);
    require 'bits/thread-shared-types.ph';
    require 'features.ph';
    require 'bits/types.ph';
    require 'bits/pthread.ph';
    eval("sub __PTHREAD_PROCESS_PRIVATE () { 0; }") unless defined(&__PTHREAD_PROCESS_PRIVATE);
    eval("sub __PTHREAD_PROCESS_SHARED () { 1; }") unless defined(&__PTHREAD_PROCESS_SHARED);
    eval("sub __PTHREAD_EXPLICIT_SCHED () { 0; }") unless defined(&__PTHREAD_EXPLICIT_SCHED);
    eval("sub __PTHREAD_INHERIT_SCHED () { 1; }") unless defined(&__PTHREAD_INHERIT_SCHED);
    eval("sub __PTHREAD_SCOPE_SYSTEM () { 0; }") unless defined(&__PTHREAD_SCOPE_SYSTEM);
    eval("sub __PTHREAD_SCOPE_PROCESS () { 1; }") unless defined(&__PTHREAD_SCOPE_PROCESS);
    eval("sub __PTHREAD_CREATE_JOINABLE () { 0; }") unless defined(&__PTHREAD_CREATE_JOINABLE);
    eval("sub __PTHREAD_CREATE_DETACHED () { 1; }") unless defined(&__PTHREAD_CREATE_DETACHED);
    require 'bits/types/struct___pthread_attr.ph';
    eval("sub __PTHREAD_PRIO_NONE () { 0; }") unless defined(&__PTHREAD_PRIO_NONE);
    eval("sub __PTHREAD_PRIO_INHERIT () { 1; }") unless defined(&__PTHREAD_PRIO_INHERIT);
    eval("sub __PTHREAD_PRIO_PROTECT () { 2; }") unless defined(&__PTHREAD_PRIO_PROTECT);
    eval("sub __PTHREAD_MUTEX_TIMED () { 0; }") unless defined(&__PTHREAD_MUTEX_TIMED);
    eval("sub __PTHREAD_MUTEX_ERRORCHECK () { 1; }") unless defined(&__PTHREAD_MUTEX_ERRORCHECK);
    eval("sub __PTHREAD_MUTEX_RECURSIVE () { 2; }") unless defined(&__PTHREAD_MUTEX_RECURSIVE);
    eval("sub __PTHREAD_MUTEX_STALLED () { 0; }") unless defined(&__PTHREAD_MUTEX_STALLED);
    eval("sub __PTHREAD_MUTEX_ROBUST () { 0x100; }") unless defined(&__PTHREAD_MUTEX_ROBUST);
    require 'bits/types/struct___pthread_mutexattr.ph';
    require 'bits/types/struct___pthread_mutex.ph';
    require 'bits/types/struct___pthread_condattr.ph';
    require 'bits/types/struct___pthread_cond.ph';
    if(defined(&__USE_XOPEN2K)) {
	require 'bits/types/__pthread_spinlock_t.ph';
    }
    if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K)) {
	require 'bits/types/struct___pthread_rwlockattr.ph';
	require 'bits/types/struct___pthread_rwlock.ph';
    }
    if(defined(&__USE_XOPEN2K)) {
	require 'bits/types/struct___pthread_barrierattr.ph';
	require 'bits/types/struct___pthread_barrier.ph';
    }
    require 'bits/types/__pthread_key.ph';
    require 'bits/types/struct___pthread_once.ph';
}
1;
