require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BITS_SIGCONTEXT_H)) {
    eval 'sub _BITS_SIGCONTEXT_H () {1;}' unless defined(&_BITS_SIGCONTEXT_H);
    if(!defined (&_SIGNAL_H)  && !defined (&_SYS_UCONTEXT_H)) {
	die("Never use <bits/sigcontext.h> directly; include <signal.h> instead.");
    }
    require 'bits/types/__sigset_t.ph';
    require 'mach/machine/fp_reg.ph';
    eval 'sub sc_i386_thread_state () { &sc_gs;}' unless defined(&sc_i386_thread_state);
    eval 'sub sc_i386_float_state () { &sc_fpkind;}' unless defined(&sc_i386_float_state);
    eval 'sub sc_sp () { &sc_uesp;}' unless defined(&sc_sp);
    eval 'sub sc_fp () { &sc_ebp;}' unless defined(&sc_fp);
    eval 'sub sc_pc () { &sc_eip;}' unless defined(&sc_pc);
    eval 'sub sc_ps () { &sc_efl;}' unless defined(&sc_ps);
    eval 'sub FPE_INTOVF_TRAP () {0x1;}' unless defined(&FPE_INTOVF_TRAP);
    eval 'sub FPE_INTDIV_FAULT () {0x2;}' unless defined(&FPE_INTDIV_FAULT);
    eval 'sub FPE_FLTOVF_FAULT () {0x3;}' unless defined(&FPE_FLTOVF_FAULT);
    eval 'sub FPE_FLTDIV_FAULT () {0x4;}' unless defined(&FPE_FLTDIV_FAULT);
    eval 'sub FPE_FLTUND_FAULT () {0x5;}' unless defined(&FPE_FLTUND_FAULT);
    eval 'sub FPE_SUBRNG_FAULT () {0x7;}' unless defined(&FPE_SUBRNG_FAULT);
    eval 'sub FPE_FLTDNR_FAULT () {0x8;}' unless defined(&FPE_FLTDNR_FAULT);
    eval 'sub FPE_FLTINX_FAULT () {0x9;}' unless defined(&FPE_FLTINX_FAULT);
    eval 'sub FPE_EMERR_FAULT () {0xa;}' unless defined(&FPE_EMERR_FAULT);
    eval 'sub FPE_EMBND_FAULT () {0xb;}' unless defined(&FPE_EMBND_FAULT);
    eval 'sub ILL_INVOPR_FAULT () {0x1;}' unless defined(&ILL_INVOPR_FAULT);
    eval 'sub ILL_STACK_FAULT () {0x2;}' unless defined(&ILL_STACK_FAULT);
    eval 'sub ILL_FPEOPR_FAULT () {0x3;}' unless defined(&ILL_FPEOPR_FAULT);
    eval 'sub DBG_SINGLE_TRAP () {0x1;}' unless defined(&DBG_SINGLE_TRAP);
    eval 'sub DBG_BRKPNT_FAULT () {0x2;}' unless defined(&DBG_BRKPNT_FAULT);
}
1;
