require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__BITS_SOCKET_H)) {
    eval 'sub __BITS_SOCKET_H () {1;}' unless defined(&__BITS_SOCKET_H);
    unless(defined(&_SYS_SOCKET_H)) {
	die("Never include <bits/socket.h> directly; use <sys/socket.h> instead.");
    }
    eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
    require 'stddef.ph';
    require 'bits/wordsize.ph';
    require 'sys/types.ph';
    unless(defined(&__socklen_t_defined)) {
	eval 'sub __socklen_t_defined () {1;}' unless defined(&__socklen_t_defined);
    }
    eval("sub SOCK_STREAM () { 1; }") unless defined(&SOCK_STREAM);
    eval("sub SOCK_DGRAM () { 2; }") unless defined(&SOCK_DGRAM);
    eval("sub SOCK_RAW () { 3; }") unless defined(&SOCK_RAW);
    eval("sub SOCK_RDM () { 4; }") unless defined(&SOCK_RDM);
    eval("sub SOCK_SEQPACKET () { 5; }") unless defined(&SOCK_SEQPACKET);
    eval("sub SOCK_CLOEXEC () { 0x00400000; }") unless defined(&SOCK_CLOEXEC);
    eval("sub SOCK_NONBLOCK () { 0x0800; }") unless defined(&SOCK_NONBLOCK);
    eval 'sub PF_UNSPEC () {0;}' unless defined(&PF_UNSPEC);
    eval 'sub PF_LOCAL () {1;}' unless defined(&PF_LOCAL);
    eval 'sub PF_UNIX () { &PF_LOCAL;}' unless defined(&PF_UNIX);
    eval 'sub PF_FILE () { &PF_LOCAL;}' unless defined(&PF_FILE);
    eval 'sub PF_INET () {2;}' unless defined(&PF_INET);
    eval 'sub PF_IMPLINK () {3;}' unless defined(&PF_IMPLINK);
    eval 'sub PF_PUP () {4;}' unless defined(&PF_PUP);
    eval 'sub PF_CHAOS () {5;}' unless defined(&PF_CHAOS);
    eval 'sub PF_NS () {6;}' unless defined(&PF_NS);
    eval 'sub PF_ISO () {7;}' unless defined(&PF_ISO);
    eval 'sub PF_OSI () { &PF_ISO;}' unless defined(&PF_OSI);
    eval 'sub PF_ECMA () {8;}' unless defined(&PF_ECMA);
    eval 'sub PF_DATAKIT () {9;}' unless defined(&PF_DATAKIT);
    eval 'sub PF_CCITT () {10;}' unless defined(&PF_CCITT);
    eval 'sub PF_SNA () {11;}' unless defined(&PF_SNA);
    eval 'sub PF_DECnet () {12;}' unless defined(&PF_DECnet);
    eval 'sub PF_DLI () {13;}' unless defined(&PF_DLI);
    eval 'sub PF_LAT () {14;}' unless defined(&PF_LAT);
    eval 'sub PF_HYLINK () {15;}' unless defined(&PF_HYLINK);
    eval 'sub PF_APPLETALK () {16;}' unless defined(&PF_APPLETALK);
    eval 'sub PF_XTP () {19;}' unless defined(&PF_XTP);
    eval 'sub PF_COIP () {20;}' unless defined(&PF_COIP);
    eval 'sub PF_CNT () {21;}' unless defined(&PF_CNT);
    eval 'sub PF_RTIP () {22;}' unless defined(&PF_RTIP);
    eval 'sub PF_IPX () {23;}' unless defined(&PF_IPX);
    eval 'sub PF_SIP () {24;}' unless defined(&PF_SIP);
    eval 'sub PF_PIP () {25;}' unless defined(&PF_PIP);
    eval 'sub PF_INET6 () {26;}' unless defined(&PF_INET6);
    eval 'sub PF_MAX () {27;}' unless defined(&PF_MAX);
    eval 'sub AF_UNSPEC () { &PF_UNSPEC;}' unless defined(&AF_UNSPEC);
    eval 'sub AF_LOCAL () { &PF_LOCAL;}' unless defined(&AF_LOCAL);
    eval 'sub AF_UNIX () { &PF_UNIX;}' unless defined(&AF_UNIX);
    eval 'sub AF_FILE () { &PF_FILE;}' unless defined(&AF_FILE);
    eval 'sub AF_INET () { &PF_INET;}' unless defined(&AF_INET);
    eval 'sub AF_IMPLINK () { &PF_IMPLINK;}' unless defined(&AF_IMPLINK);
    eval 'sub AF_PUP () { &PF_PUP;}' unless defined(&AF_PUP);
    eval 'sub AF_CHAOS () { &PF_CHAOS;}' unless defined(&AF_CHAOS);
    eval 'sub AF_NS () { &PF_NS;}' unless defined(&AF_NS);
    eval 'sub AF_ISO () { &PF_ISO;}' unless defined(&AF_ISO);
    eval 'sub AF_OSI () { &PF_OSI;}' unless defined(&AF_OSI);
    eval 'sub AF_ECMA () { &PF_ECMA;}' unless defined(&AF_ECMA);
    eval 'sub AF_DATAKIT () { &PF_DATAKIT;}' unless defined(&AF_DATAKIT);
    eval 'sub AF_CCITT () { &PF_CCITT;}' unless defined(&AF_CCITT);
    eval 'sub AF_SNA () { &PF_SNA;}' unless defined(&AF_SNA);
    eval 'sub AF_DECnet () { &PF_DECnet;}' unless defined(&AF_DECnet);
    eval 'sub AF_DLI () { &PF_DLI;}' unless defined(&AF_DLI);
    eval 'sub AF_LAT () { &PF_LAT;}' unless defined(&AF_LAT);
    eval 'sub AF_HYLINK () { &PF_HYLINK;}' unless defined(&AF_HYLINK);
    eval 'sub AF_APPLETALK () { &PF_APPLETALK;}' unless defined(&AF_APPLETALK);
    if(defined(&__USE_MISC)) {
	eval 'sub pseudo_AF_XTP () { &PF_XTP;}' unless defined(&pseudo_AF_XTP);
    }
    eval 'sub AF_COIP () { &PF_COIP;}' unless defined(&AF_COIP);
    eval 'sub AF_CNT () { &PF_CNT;}' unless defined(&AF_CNT);
    if(defined(&__USE_MISC)) {
	eval 'sub pseudo_AF_RTIP () { &PF_RTIP;}' unless defined(&pseudo_AF_RTIP);
    }
    eval 'sub AF_IPX () { &PF_IPX;}' unless defined(&AF_IPX);
    eval 'sub AF_SIP () { &PF_SIP;}' unless defined(&AF_SIP);
    if(defined(&__USE_MISC)) {
	eval 'sub pseudo_AF_PIP () { &PF_PIP;}' unless defined(&pseudo_AF_PIP);
    }
    eval 'sub AF_INET6 () { &PF_INET6;}' unless defined(&AF_INET6);
    eval 'sub AF_MAX () { &PF_MAX;}' unless defined(&AF_MAX);
    eval 'sub SOMAXCONN () {4096;}' unless defined(&SOMAXCONN);
    require 'bits/sockaddr.ph';
    if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	eval 'sub __ss_aligntype () { &__uint64_t;}' unless defined(&__ss_aligntype);
    } else {
	eval 'sub __ss_aligntype () { &__uint32_t;}' unless defined(&__ss_aligntype);
    }
    eval 'sub _SS_PADSIZE () {( &_SS_SIZE -  &__SOCKADDR_COMMON_SIZE - $sizeof{ &__ss_aligntype});}' unless defined(&_SS_PADSIZE);
    eval("sub MSG_OOB () { 0x01; }") unless defined(&MSG_OOB);
    eval("sub MSG_PEEK () { 0x02; }") unless defined(&MSG_PEEK);
    eval("sub MSG_DONTROUTE () { 0x04; }") unless defined(&MSG_DONTROUTE);
    eval("sub MSG_EOR () { 0x08; }") unless defined(&MSG_EOR);
    eval("sub MSG_TRUNC () { 0x10; }") unless defined(&MSG_TRUNC);
    eval("sub MSG_CTRUNC () { 0x20; }") unless defined(&MSG_CTRUNC);
    eval("sub MSG_WAITALL () { 0x40; }") unless defined(&MSG_WAITALL);
    eval("sub MSG_DONTWAIT () { 0x80; }") unless defined(&MSG_DONTWAIT);
    eval("sub MSG_NOSIGNAL () { 0x0400; }") unless defined(&MSG_NOSIGNAL);
    eval("sub MSG_CMSG_CLOEXEC () { 0x40000; }") unless defined(&MSG_CMSG_CLOEXEC);
    if((defined(&__glibc_c99_flexarr_available) ? &__glibc_c99_flexarr_available : undef)) {
    }
    if((defined(&__glibc_c99_flexarr_available) ? &__glibc_c99_flexarr_available : undef)) {
	eval 'sub CMSG_DATA {
	    my($cmsg) = @_;
    	    eval q((($cmsg)-> &__cmsg_data));
	}' unless defined(&CMSG_DATA);
    } else {
	eval 'sub CMSG_DATA {
	    my($cmsg) = @_;
    	    eval q(( ( ($cmsg) + 1)));
	}' unless defined(&CMSG_DATA);
    }
    eval 'sub CMSG_NXTHDR {
        my($mhdr, $cmsg) = @_;
	    eval q( &__cmsg_nxthdr ($mhdr, $cmsg));
    }' unless defined(&CMSG_NXTHDR);
    eval 'sub CMSG_FIRSTHDR {
        my($mhdr) = @_;
	    eval q(( ($mhdr)-> &msg_controllen >= $sizeof{\'struct cmsghdr\'} ?  ($mhdr)-> &msg_control :  0));
    }' unless defined(&CMSG_FIRSTHDR);
    eval 'sub CMSG_ALIGN {
        my($len) = @_;
	    eval q(((($len) + $sizeof{\'size_t\'} - 1) &  ~($sizeof{\'size_t\'} - 1)));
    }' unless defined(&CMSG_ALIGN);
    eval 'sub CMSG_SPACE {
        my($len) = @_;
	    eval q(( &CMSG_ALIGN ($len) +  &CMSG_ALIGN ($sizeof{\'struct cmsghdr\'})));
    }' unless defined(&CMSG_SPACE);
    eval 'sub CMSG_LEN {
        my($len) = @_;
	    eval q(( &CMSG_ALIGN ($sizeof{\'struct cmsghdr\'}) + ($len)));
    }' unless defined(&CMSG_LEN);
    eval 'sub __CMSG_PADDING {
        my($len) = @_;
	    eval q((($sizeof{\'size_t\'} - (($len) & ($sizeof{\'size_t\'} - 1))) & ($sizeof{\'size_t\'} - 1)));
    }' unless defined(&__CMSG_PADDING);
    if(defined(&__USE_EXTERN_INLINES)) {
	unless(defined(&_EXTERN_INLINE)) {
	    eval 'sub _EXTERN_INLINE () { &__extern_inline;}' unless defined(&_EXTERN_INLINE);
	}
    }
    eval("sub SCM_RIGHTS () { 0x01; }") unless defined(&SCM_RIGHTS);
    eval("sub SCM_TIMESTAMP () { 0x02; }") unless defined(&SCM_TIMESTAMP);
    eval("sub SCM_CREDS () { 0x03; }") unless defined(&SCM_CREDS);
    if(defined(&__USE_MISC)) {
	eval 'sub CMGROUP_MAX () {16;}' unless defined(&CMGROUP_MAX);
    }
    eval 'sub SOL_SOCKET () {0xffff;}' unless defined(&SOL_SOCKET);
    eval("sub SO_DEBUG () { 0x0001; }") unless defined(&SO_DEBUG);
    eval("sub SO_ACCEPTCONN () { 0x0002; }") unless defined(&SO_ACCEPTCONN);
    eval("sub SO_REUSEADDR () { 0x0004; }") unless defined(&SO_REUSEADDR);
    eval("sub SO_KEEPALIVE () { 0x0008; }") unless defined(&SO_KEEPALIVE);
    eval("sub SO_DONTROUTE () { 0x0010; }") unless defined(&SO_DONTROUTE);
    eval("sub SO_BROADCAST () { 0x0020; }") unless defined(&SO_BROADCAST);
    eval("sub SO_USELOOPBACK () { 0x0040; }") unless defined(&SO_USELOOPBACK);
    eval("sub SO_LINGER () { 0x0080; }") unless defined(&SO_LINGER);
    eval("sub SO_OOBINLINE () { 0x0100; }") unless defined(&SO_OOBINLINE);
    eval("sub SO_REUSEPORT () { 0x0200; }") unless defined(&SO_REUSEPORT);
    eval("sub SO_SNDBUF () { 0x1001; }") unless defined(&SO_SNDBUF);
    eval("sub SO_RCVBUF () { 0x1002; }") unless defined(&SO_RCVBUF);
    eval("sub SO_SNDLOWAT () { 0x1003; }") unless defined(&SO_SNDLOWAT);
    eval("sub SO_RCVLOWAT () { 0x1004; }") unless defined(&SO_RCVLOWAT);
    eval("sub SO_SNDTIMEO () { 0x1005; }") unless defined(&SO_SNDTIMEO);
    eval("sub SO_RCVTIMEO () { 0x1006; }") unless defined(&SO_RCVTIMEO);
    eval("sub SO_ERROR () { 0x1007; }") unless defined(&SO_ERROR);
    eval("sub SO_STYLE () { 0x1008; }") unless defined(&SO_STYLE);
    eval("sub SO_TYPE () { SO_STYLE; }") unless defined(&SO_TYPE);
}
1;
